/*************************************************************
 *                                                           *
 * file  : ARB_texture_cube_map.h                            *
 * author: Jens Schneider                                    *
 * date  : 01.Mar.2001                                       *
 * e-mail: jens@glHint.de                                    *
 *                                                           *
 * version 1.0 tested                                        *
 *                                                           *
 * ABOUT:                                                    *
 * ======                                                    *
 * Header-file to use the OpenGL-extension                   *
 * GL_ARB_texture_cube_map.                                  *
 *                                                           *
 * See specification of the GL_ARB_texture_cube_map          * 
 * extension for more detail, available at www.opengl.org.   *
 *                                                           *
 *************************************************************/

#ifndef __ARB_TEXTURE_CUBE_MAP_H_
#define __ARB_TEXTURE_CUBE_MAP_H_

/*
 *  GLOBAL SWITCHES - enable/disable advanced features of this header
 *
 */
#define ARB_TEXTURE_CUBE_MAP_INITIALIZE 1 // enable generic init-routines
//#define GL_GLEXT_PROTOTYPES 1

#ifdef __cplusplus
extern "C" {
#endif

#if defined(_WIN32) && !defined(APIENTRY) && !defined(__CYGWIN__)
#define WIN32_LEAN_AND_MEAN 1
#include <windows.h>
#endif

#ifndef APIENTRY
#define APIENTRY
#endif


// Header file version number, required by OpenGL ABI for Linux
#define GL_GLEXT_VERSION 7


/* 
 * NEW TOKENS TO OPENGL 1.2.1 
 *
 */
#ifndef GL_ARB_texture_cube_map
#define GL_NORMAL_MAP_ARB					0x8511
#define GL_REFLECTION_MAP_ARB				0x8512
#define GL_TEXTURE_CUBE_MAP_ARB				0x8513
#define GL_TEXTURE_BINDING_CUBE_MAP_ARB		0x8514
#define GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB	0x8515
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB	0x8516
#define GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB	0x8517
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB	0x8518
#define GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB	0x8519
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB	0x851A
#define GL_PROXY_TEXTURE_CUBE_MAP_ARB		0x851B
#define GL_MAX_CUBE_MAP_TEXTURE_SIZE_ARB	0x851C
#endif

#ifndef GL_ARB_texture_cube_map
#define GL_ARB_texture_cube_map 1

#ifdef GL_GLEXT_PROTOTYPES
#endif

#endif // not GL_ARB_texture_cube_map

#ifdef ARB_TEXTURE_CUBE_MAP_INITIALIZE
#include<string.h>		// string manipulation for runtime-check

#ifdef _WIN32
#endif // _WIN32

int CheckForARBTextureCubeMapSupport(void) {
	const char search[]="GL_ARB_texture_cube_map";
	char string[10000];
	int pos=0;
	int maxpos=strlen(search)-1;
	strcpy(string,(const char *)glGetString(GL_EXTENSIONS));
	int len=strlen(string);	
	for (int i=0; i<len; i++) {
		if ((i==0) || ((i>1) && string[i-1]==' ')) {
			pos=0;									
			while (string[i]!='\n') {				
				if (string[i]==search[pos]) pos++;	
				if ((pos>maxpos) && string[i+1]==' ') {
					printf(search);
					printf(" supported.\n");
					return 1;
				}
				i++;
			}			
		}
	}	
	fprintf(stderr,search);
	fprintf(stderr, " not supported.\n");
	return 0;	
}

int GL_ARB_texture_cube_map_Init(void) {
	if (!CheckForARBTextureCubeMapSupport()) return 0;
	return 1;
}

#endif // ARB_TEXTURE_CUBE_MAP_INITIALIZE

#ifdef __cplusplus
}

#endif

#endif // not __ARB_TEXTURE_CUBE_MAP_H_
