/*************************************************************
 *                                                           *
 * file  : NV_vertex_program.h                               *
 * author: Jens Schneider                                    *
 * date  : 01.Mar.2001                                       *
 * e-mail: jens@glHint.de                                    *
 *                                                           *
 * version 1.0 tested                                        *
 *                                                           *
 * ABOUT:                                                    *
 * ======                                                    *
 * Header-file to use the OpenGL-extension                   *
 * GL_NV_vertex_program by nVidia.	                         *
 *                                                           *
 *                                                           *
 * See specification of the GL_NV_vertex_program for more    *
 * detail. Specification is available at www.nVidia.com.     *
 *                                                           *
 *************************************************************/

#ifndef __NV_VERTEX_PROGRAM_H_
#define __NV_VERTEX_PROGRAM_H_

/*
 *  GLOBAL SWITCHES - enable/disable advanced features of this header
 *
 */
#define NV_VERTEX_PROGRAM_INITIALIZE 1 // enable generic init-routines
//#define GL_GLEXT_PROTOTYPES 1

#ifdef __cplusplus
extern "C" {
#endif

#if defined(_WIN32) && !defined(APIENTRY) && !defined(__CYGWIN__)
#define WIN32_LEAN_AND_MEAN 1
#include <windows.h>
#endif

#ifndef APIENTRY
#define APIENTRY
#endif


// Header file version number, required by OpenGL ABI for Linux
#define GL_GLEXT_VERSION 7


/* 
 * NEW TOKENS TO OPENGL 1.2.1 
 *
 */
#ifndef GL_NV_vertex_program

#define GL_VERTEX_PROGRAM_NV				0x8620
#define GL_VERTEX_STATE_PROGRAM_NV			0x8621
// 0x8622
#define GL_ATTRIB_ARRAY_SIZE_NV				0x8623
#define GL_ATTRIB_ARRAY_STRIDE_NV			0x8624
#define GL_ATTRIB_ARRAY_TYPE_NV				0x8625
#define GL_CURRENT_ATTRIB_NV				0x8626
#define GL_PROGRAM_LENGTH_NV				0x8627
#define GL_PROGRAM_STRING_NV				0x8628
#define GL_MODELVIEW_PROJECTION_NV			0x8629
#define GL_IDENTITY_NV						0x862A
#define GL_INVERSE_NV						0x862B
#define GL_TRANSPOSE_NV						0x862C
#define GL_INVERSE_TRANSPOSE_NV				0x862D
#define GL_MAX_TRACK_MATRIX_STACK_DEPTH_NV	0x862E
#define GL_MAX_TRACK_MATRICES_NV			0x862F
#define GL_MATRIX0_NV						0x8630
#define GL_MATRIX1_NV						0x8631
#define GL_MATRIX2_NV						0x8632
#define GL_MATRIX3_NV						0x8633
#define GL_MATRIX4_NV						0x8634
#define GL_MATRIX5_NV						0x8635
#define GL_MATRIX6_NV						0x8636
#define GL_MATRIX7_NV						0x8637
#define GL_MATRIX8_NV						0x8638
#define GL_MATRIX9_NV						0x8639
#define GL_MATRIX10_NV						0x863A
#define GL_MATRIX11_NV						0x863B
#define GL_MATRIX12_NV						0x863C
#define GL_MATRIX13_NV						0x863D
#define GL_MATRIX14_NV						0x863E
#define GL_MATRIX15_NV						0x863F
#define GL_CURRENT_MATRIX_STACK_DEPTH_NV	0x8640
#define GL_CURRENT_MATRIX_NV				0x8641
#define GL_VERTEX_PROGRAM_POINT_SIZE_NV		0x8642
#define GL_VERTEX_PROGRAM_TWO_SIDE_NV		0x8643
#define GL_PROGRAM_PARAMETER_NV				0x8644
#define GL_ATTRIB_ARRAY_POINTER_NV			0x8645
#define GL_PROGRAM_TARGET_NV				0x8646
#define GL_PROGRAM_RESIDENT_NV				0x8647
#define GL_TRACK_MATRIX_NV					0x8648
#define GL_TRACK_MATRIX_TRANSFORM_NV		0x8649
#define GL_VERTEX_PROGRAM_BINDING_NV		0x864A
#define GL_PROGRAM_ERROR_POSITION_NV		0x864B
#define GL_VERTEX_ATTRIB_ARRAY0_NV			0x8650
#define GL_VERTEX_ATTRIB_ARRAY1_NV			0x8651
#define GL_VERTEX_ATTRIB_ARRAY2_NV			0x8652
#define GL_VERTEX_ATTRIB_ARRAY3_NV			0x8653
#define GL_VERTEX_ATTRIB_ARRAY4_NV			0x8654
#define GL_VERTEX_ATTRIB_ARRAY5_NV			0x8655
#define GL_VERTEX_ATTRIB_ARRAY6_NV			0x8656
#define GL_VERTEX_ATTRIB_ARRAY7_NV			0x8657
#define GL_VERTEX_ATTRIB_ARRAY8_NV			0x8658
#define GL_VERTEX_ATTRIB_ARRAY9_NV			0x8659
#define GL_VERTEX_ATTRIB_ARRAY10_NV			0x865A
#define GL_VERTEX_ATTRIB_ARRAY11_NV			0x865B
#define GL_VERTEX_ATTRIB_ARRAY12_NV			0x865C
#define GL_VERTEX_ATTRIB_ARRAY13_NV			0x865D
#define GL_VERTEX_ATTRIB_ARRAY14_NV			0x865E
#define GL_VERTEX_ATTRIB_ARRAY15_NV			0x865F
#define GL_MAP1_VERTEX_ATTRIB0_4_NV			0x8660
#define GL_MAP1_VERTEX_ATTRIB1_4_NV			0x8661
#define GL_MAP1_VERTEX_ATTRIB2_4_NV			0x8662
#define GL_MAP1_VERTEX_ATTRIB3_4_NV			0x8663
#define GL_MAP1_VERTEX_ATTRIB4_4_NV			0x8664
#define GL_MAP1_VERTEX_ATTRIB5_4_NV			0x8665
#define GL_MAP1_VERTEX_ATTRIB6_4_NV			0x8666
#define GL_MAP1_VERTEX_ATTRIB7_4_NV			0x8667
#define GL_MAP1_VERTEX_ATTRIB8_4_NV			0x8668
#define GL_MAP1_VERTEX_ATTRIB9_4_NV			0x8669
#define GL_MAP1_VERTEX_ATTRIB10_4_NV		0x866A
#define GL_MAP1_VERTEX_ATTRIB11_4_NV		0x866B
#define GL_MAP1_VERTEX_ATTRIB12_4_NV		0x866C
#define GL_MAP1_VERTEX_ATTRIB13_4_NV		0x866D
#define GL_MAP1_VERTEX_ATTRIB14_4_NV		0x866E
#define GL_MAP1_VERTEX_ATTRIB15_4_NV		0x866F
#define GL_MAP2_VERTEX_ATTRIB0_4_NV			0x8670
#define GL_MAP2_VERTEX_ATTRIB1_4_NV			0x8671
#define GL_MAP2_VERTEX_ATTRIB2_4_NV			0x8672
#define GL_MAP2_VERTEX_ATTRIB3_4_NV			0x8673
#define GL_MAP2_VERTEX_ATTRIB4_4_NV			0x8674
#define GL_MAP2_VERTEX_ATTRIB5_4_NV			0x8675
#define GL_MAP2_VERTEX_ATTRIB6_4_NV			0x8676
#define GL_MAP2_VERTEX_ATTRIB7_4_NV			0x8677
#define GL_MAP2_VERTEX_ATTRIB8_4_NV			0x8678
#define GL_MAP2_VERTEX_ATTRIB9_4_NV			0x8679
#define GL_MAP2_VERTEX_ATTRIB10_4_NV		0x867A
#define GL_MAP2_VERTEX_ATTRIB11_4_NV		0x867B
#define GL_MAP2_VERTEX_ATTRIB12_4_NV		0x867C
#define GL_MAP2_VERTEX_ATTRIB13_4_NV		0x867D
#define GL_MAP2_VERTEX_ATTRIB14_4_NV		0x867E
#define GL_MAP2_VERTEX_ATTRIB15_4_NV		0x867F

// re-uses GL_NONE, GL_MODELVIEW, GL_PROJECTION, GL_TEXTURE, GL_COLOR 

#endif


#ifndef GL_NV_vertex_program
#define GL_NV_vertex_program 1

#ifdef GL_GLEXT_PROTOTYPES
extern void APIENTRY		glBindProgramNV (GLenum, GLuint);
extern void APIENTRY		glDeleteProgramsNV (GLsizei, const GLuint *);
extern void APIENTRY		glExecuteProgramNV (GLsizei, GLuint, const GLfloat *);
extern void APIENTRY		glGenProgramsNV (GLsizei, GLuint *);
extern void APIENTRY		glRequestResidentProgramsNV (GLsizei, GLuint *);
extern void APIENTRY		glGetProgramParameterfvNV (GLenum, GLuint, GLenum, GLfloat *);
extern void APIENTRY		glGetProgramParameterdvNV (GLenum, GLuint, GLenum, GLfloat *);
extern void APIENTRY		glGetProgramivNV (GLuint, GLenum, GLint *);
extern void APIENTRY		glGetProgramStringNV (GLuint, GLenum, GLuint *);
extern void APIENTRY		glGetTrackMatrixivNV (GLenum, GLuint, GLenum, GLuint *);
extern void APIENTRY		glGetVertexAttribdvNV (GLuint, GLenum, GLdouble *);
extern void APIENTRY		glGetVertexAttribfvNV (GLuint, GLenum, GLfloat *);
extern void APIENTRY		glGetVertexAttribivNV (GLuint, GLenum, GLint *);
extern void APIENTRY		glGetVertexAttribPointerNV (GLuint, GLenum, Glvoid **);
extern void APIENTRY		glLoadProgramNV (GLenum, GLuint, GLsizei, const GLubyte *);
extern void APIENTRY		glProgramParameter4dNV (GLenum, GLuint, GLdouble, GLdouble, GLdouble, GLdouble);
extern void APIENTRY		glProgramParameter4fNV (GLenum, GLuint, GLfloat, GLfloat, GLfloat, GLfloat);
extern void APIENTRY		glProgramParameter4dvNV (GLenum, GLuint, const GLdouble *);
extern void APIENTRY		glProgramParameter4fvNV (GLenum, GLuint, const GLfloat *);
extern void APIENTRY		glProgramParameters4dvNV (GLenum, GLuint, GLuint, const GLdouble *);
extern void APIENTRY		glProgramParameters4fvNV (GLenum, GLuint, GLuint, const GLfloat *);
extern void APIENTRY		glTrackMatrixNV (GLenum, GLuint, GLenum, GLenum);
extern void APIENTRY		glVertexAttribPointerNV (GLuint, GLint, GLenum, GLsizei, const GLvoid *);
extern void APIENTRY		glVertexAttrib1sNV (GLuint, GLshort);
extern void APIENTRY		glVertexAttrib1fNV (GLuint, GLfloat);
extern void APIENTRY		glVertexAttrib1dNV (GLuint, GLdouble);
extern void APIENTRY		glVertexAttrib2sNV (GLuint, GLshort, GLshort);
extern void APIENTRY		glVertexAttrib2fNV (GLuint, GLfloat, GLfloat);
extern void APIENTRY		glVertexAttrib2dNV (GLuint, GLdouble, GLdouble);
extern void APIENTRY		glVertexAttrib3sNV (GLuint, GLshort, GLshort, GLshort);
extern void APIENTRY		glVertexAttrib3fNV (GLuint, GLfloat, GLfloat, GLfloat);
extern void APIENTRY		glVertexAttrib3dNV (GLuint, GLdouble, GLdouble, GLdouble);
extern void APIENTRY		glVertexAttrib4sNV (GLuint, GLshort, GLshort, GLshort, GLshort);
extern void APIENTRY		glVertexAttrib4fNV (GLuint, GLfloat, GLfloat, GLfloat, GLfloat);
extern void APIENTRY		glVertexAttrib4dNV (GLuint, GLdouble, GLdouble, GLdouble, GLdouble);
extern void APIENTRY		glVertexAttrib4ubNV (GLuint, GLubyte, GLubyte, GLubyte, GLubyte);
extern void APIENTRY		glVertexAttrib1svNV (GLuint, GLshort *);
extern void APIENTRY		glVertexAttrib1fvNV (GLuint, GLfloat *);
extern void APIENTRY		glVertexAttrib1dvNV (GLuint, GLdouble *);
extern void APIENTRY		glVertexAttrib2svNV (GLuint, GLshort *);
extern void APIENTRY		glVertexAttrib2fvNV (GLuint, GLfloat *);
extern void APIENTRY		glVertexAttrib2dvNV (GLuint, GLdouble *);
extern void APIENTRY		glVertexAttrib3svNV (GLuint, GLshort *);
extern void APIENTRY		glVertexAttrib3fvNV (GLuint, GLfloat *);
extern void APIENTRY		glVertexAttrib3dvNV (GLuint, GLdouble *);
extern void APIENTRY		glVertexAttrib4svNV (GLuint, GLshort *);
extern void APIENTRY		glVertexAttrib4fvNV (GLuint, GLfloat *);
extern void APIENTRY		glVertexAttrib4dvNV (GLuint, GLdouble *);
extern void APIENTRY		glVertexAttrib4ubvNV (GLuint, GLubyte *);
extern GLboolean APIENTRY	glAreProgramsResidentNV (GLsizei, const GLuint *, GLboolean *);
extern GLboolean APIENTRY	glIsProgramNV (GLuint);
#endif // GL_GLEXT_PROTOTYPES 

typedef void (APIENTRY * PFNGLBINDPROGRAMNVPROC) (GLenum target, GLuint id);
typedef void (APIENTRY * PFNGLDELETEPROGRAMSNVPROC) (GLsizei n, const GLuint *ids);
typedef void (APIENTRY * PFNGLEXECUTEPROGRAMNVPROC) (GLenum target, GLuint id, const GLfloat *params);
typedef void (APIENTRY * PFNGLGENPROGRAMSNVPROC) (GLsizei n, GLuint *ids);
typedef void (APIENTRY * PFNGLREQUESTRESIDENTPROGRAMSNVPROC) (GLsizei n, GLuint *ids);
typedef void (APIENTRY * PFNGLGETPROGRAMPARAMETERFVNVPROC) (GLenum target, GLuint index, GLenum pname, GLfloat *params);
typedef void (APIENTRY * PFNGLGETPROGRAMPARAMETERDVNVPROC) (GLenum target, GLuint index, GLenum pname, GLfloat *params);
typedef void (APIENTRY * PFNGLGETPROGRAMIVNVPROC) (GLuint id, GLenum pname, GLint *params);
typedef void (APIENTRY * PFNGLGETPROGRAMSTRINGNVPROC) (GLuint id, GLenum pname, GLuint *program);
typedef void (APIENTRY * PFNGLGETTRACKMATRIXIVNVPROC) (GLenum target, GLuint address, GLenum pname, GLuint *params);
typedef void (APIENTRY * PFNGLGETVERTEXATTRIBDVNVPROC) (GLuint index, GLenum pname, GLdouble *params);
typedef void (APIENTRY * PFNGLGETVERTEXATTRIBFVNVPROC) (GLuint index, GLenum pname, GLfloat *params);
typedef void (APIENTRY * PFNGLGETVERTEXATTRIBIVNVPROC) (GLuint index, GLenum pname, GLint *params);
typedef void (APIENTRY * PFNGLGETVERTEXATTRIBPOINTERNVPROC) (GLuint index, GLenum pname, GLvoid **pointer);
typedef void (APIENTRY * PFNGLLOADPROGRAMNVPROC) (GLenum target, GLuint id, GLsizei len, const GLubyte *program);
typedef void (APIENTRY * PFNGLPROGRAMPARAMETER4DNVPROC) (GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
typedef void (APIENTRY * PFNGLPROGRAMPARAMETER4FNVPROC) (GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
typedef void (APIENTRY * PFNGLPROGRAMPARAMETER4DVNVPROC) (GLenum target, GLuint index, const GLdouble *params);
typedef void (APIENTRY * PFNGLPROGRAMPARAMETER4FVNVPROC) (GLenum target, GLuint index, const GLfloat *params);
typedef void (APIENTRY * PFNGLPROGRAMPARAMETERS4DVNVPROC) (GLenum target, GLuint index, GLuint num, const GLdouble *params);
typedef void (APIENTRY * PFNGLPROGRAMPARAMETERS4FVNVPROC) (GLenum target, GLuint index, GLuint num, const GLfloat *params);
typedef void (APIENTRY * PFNGLTRACKMATRIXNVPROC) (GLenum target, GLuint address, GLenum martrix, GLenum transform);
typedef void (APIENTRY * PFNGLVERTEXATTRIBPOINTERNVPROC) (GLuint index, GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
typedef void (APIENTRY * PFNGLVERTEXATTRIB1SNVPROC) (GLuint index, GLshort x);
typedef void (APIENTRY * PFNGLVERTEXATTRIB1FNVPROC) (GLuint index, GLfloat x);
typedef void (APIENTRY * PFNGLVERTEXATTRIB1DNVPROC) (GLuint index, GLdouble x);
typedef void (APIENTRY * PFNGLVERTEXATTRIB2SNVPROC) (GLuint index, GLshort x, GLshort y);
typedef void (APIENTRY * PFNGLVERTEXATTRIB2FNVPROC) (GLuint index, GLfloat x, GLfloat y);
typedef void (APIENTRY * PFNGLVERTEXATTRIB2DNVPROC) (GLuint index, GLdouble x, GLdouble y);
typedef void (APIENTRY * PFNGLVERTEXATTRIB3SNVPROC) (GLuint index, GLshort x, GLshort y, GLshort z);
typedef void (APIENTRY * PFNGLVERTEXATTRIB3FNVPROC) (GLuint index, GLfloat x, GLfloat y, GLfloat z);
typedef void (APIENTRY * PFNGLVERTEXATTRIB3DNVPROC) (GLuint index, GLdouble x, GLdouble y, GLdouble z);
typedef void (APIENTRY * PFNGLVERTEXATTRIB4SNVPROC) (GLuint index, GLshort x, GLshort y, GLshort z, GLshort w);
typedef void (APIENTRY * PFNGLVERTEXATTRIB4FNVPROC) (GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
typedef void (APIENTRY * PFNGLVERTEXATTRIB4DNVPROC) (GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
typedef void (APIENTRY * PFNGLVERTEXATTRIB4UBNVPROC) (GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w);
typedef void (APIENTRY * PFNGLVERTEXATTRIB1SVNVPROC) (GLuint index, GLshort *v);
typedef void (APIENTRY * PFNGLVERTEXATTRIB1FVNVPROC) (GLuint index, GLfloat *v);
typedef void (APIENTRY * PFNGLVERTEXATTRIB1DVNVPROC) (GLuint index, GLdouble *v);
typedef void (APIENTRY * PFNGLVERTEXATTRIB2SVNVPROC) (GLuint index, GLshort *v);
typedef void (APIENTRY * PFNGLVERTEXATTRIB2FVNVPROC) (GLuint index, GLfloat *v);
typedef void (APIENTRY * PFNGLVERTEXATTRIB2DVNVPROC) (GLuint index, GLdouble *v);
typedef void (APIENTRY * PFNGLVERTEXATTRIB3SVNVPROC) (GLuint index, GLshort *v);
typedef void (APIENTRY * PFNGLVERTEXATTRIB3FVNVPROC) (GLuint index, GLfloat *v);
typedef void (APIENTRY * PFNGLVERTEXATTRIB3DVNVPROC) (GLuint index, GLdouble *v);
typedef void (APIENTRY * PFNGLVERTEXATTRIB4SVNVPROC) (GLuint index, GLshort *v);
typedef void (APIENTRY * PFNGLVERTEXATTRIB4FVNVPROC) (GLuint index, GLfloat *v);
typedef void (APIENTRY * PFNGLVERTEXATTRIB4DVNVPROC) (GLuint index, GLdouble *v);
typedef void (APIENTRY * PFNGLVERTEXATTRIB4UBVNVPROC) (GLuint index, GLubyte *v);
typedef GLboolean (APIENTRY * PFNGLAREPROGRAMSRESIDENTNVPROC) (GLsizei n, const GLuint *ids, GLboolean *residences);
typedef GLboolean (APIENTRY * PFNGLISPROGRAMNVPROC) (GLuint id);
#endif // not GL_NV_vertex_program

#ifdef NV_VERTEX_PROGRAM_INITIALIZE
#include<string.h>		// string manipulation for runtime-check

#ifdef _WIN32
PFNGLBINDPROGRAMNVPROC				glBindProgramNV = NULL;
PFNGLDELETEPROGRAMSNVPROC			glDeleteProgramsNV = NULL;
PFNGLEXECUTEPROGRAMNVPROC			glExecuteProgramNV = NULL;
PFNGLGENPROGRAMSNVPROC				glGenProgramsNV = NULL;
PFNGLREQUESTRESIDENTPROGRAMSNVPROC	glRequestResidentProgramsNV = NULL;
PFNGLGETPROGRAMPARAMETERFVNVPROC	glGetProgramParameterfvNV = NULL;
PFNGLGETPROGRAMPARAMETERDVNVPROC	glGetProgramParameterdvNV = NULL;
PFNGLGETPROGRAMIVNVPROC				glGetProgramivNV = NULL;
PFNGLGETPROGRAMSTRINGNVPROC			glGetProgramStringNV = NULL;
PFNGLGETTRACKMATRIXIVNVPROC			glGetTrackMatrixivNV = NULL;
PFNGLGETVERTEXATTRIBDVNVPROC		glGetVertexAttribdvNV = NULL;
PFNGLGETVERTEXATTRIBFVNVPROC		glGetVertexAttribfvNV = NULL;
PFNGLGETVERTEXATTRIBIVNVPROC		glGetVertexAttribivNV = NULL;
PFNGLGETVERTEXATTRIBPOINTERNVPROC	glGetVertexAttribPointerNV = NULL;
PFNGLLOADPROGRAMNVPROC				glLoadProgramNV = NULL;
PFNGLPROGRAMPARAMETER4DNVPROC		glProgramParameter4dNV = NULL;
PFNGLPROGRAMPARAMETER4FNVPROC		glProgramParameter4fNV = NULL;
PFNGLPROGRAMPARAMETER4DVNVPROC		glProgramParameter4dvNV = NULL;
PFNGLPROGRAMPARAMETER4FVNVPROC		glProgramParameter4fvNV = NULL;
PFNGLPROGRAMPARAMETERS4DVNVPROC		glProgramParameters4dvNV = NULL;
PFNGLPROGRAMPARAMETERS4FVNVPROC		glProgramParameters4fvNV = NULL;
PFNGLTRACKMATRIXNVPROC				glTrackMatrixNV = NULL;
PFNGLVERTEXATTRIBPOINTERNVPROC		glVertexAttribPointerNV = NULL;
PFNGLVERTEXATTRIB1SNVPROC			glVertexAttrib1sNV = NULL;
PFNGLVERTEXATTRIB1FNVPROC			glVertexAttrib1fNV = NULL;
PFNGLVERTEXATTRIB1DNVPROC			glVertexAttrib1dNV = NULL;
PFNGLVERTEXATTRIB2SNVPROC			glVertexAttrib2sNV = NULL;
PFNGLVERTEXATTRIB2FNVPROC			glVertexAttrib2fNV = NULL;
PFNGLVERTEXATTRIB2DNVPROC			glVertexAttrib2dNV = NULL;
PFNGLVERTEXATTRIB3SNVPROC			glVertexAttrib3sNV = NULL;
PFNGLVERTEXATTRIB3FNVPROC			glVertexAttrib3fNV = NULL;
PFNGLVERTEXATTRIB3DNVPROC			glVertexAttrib3dNV = NULL;
PFNGLVERTEXATTRIB4SNVPROC			glVertexAttrib4sNV = NULL;
PFNGLVERTEXATTRIB4FNVPROC			glVertexAttrib4fNV = NULL;
PFNGLVERTEXATTRIB4DNVPROC			glVertexAttrib4dNV = NULL;
PFNGLVERTEXATTRIB4UBNVPROC			glVertexAttrib4ubNV = NULL;
PFNGLVERTEXATTRIB1SVNVPROC			glVertexAttrib1svNV = NULL;
PFNGLVERTEXATTRIB1FVNVPROC			glVertexAttrib1fvNV = NULL;
PFNGLVERTEXATTRIB1DVNVPROC			glVertexAttrib1dvNV = NULL;
PFNGLVERTEXATTRIB2SVNVPROC			glVertexAttrib2svNV = NULL;
PFNGLVERTEXATTRIB2FVNVPROC			glVertexAttrib2fvNV = NULL;
PFNGLVERTEXATTRIB2DVNVPROC			glVertexAttrib2dvNV = NULL;
PFNGLVERTEXATTRIB3SVNVPROC			glVertexAttrib3svNV = NULL;
PFNGLVERTEXATTRIB3FVNVPROC			glVertexAttrib3fvNV = NULL;
PFNGLVERTEXATTRIB3DVNVPROC			glVertexAttrib3dvNV = NULL;
PFNGLVERTEXATTRIB4SVNVPROC			glVertexAttrib4svNV = NULL;
PFNGLVERTEXATTRIB4FVNVPROC			glVertexAttrib4fvNV = NULL;
PFNGLVERTEXATTRIB4DVNVPROC			glVertexAttrib4dvNV = NULL;
PFNGLVERTEXATTRIB4UBVNVPROC			glVertexAttrib4ubvNV = NULL;
PFNGLAREPROGRAMSRESIDENTNVPROC	 	glAreProgramsResidentNV = NULL;
PFNGLISPROGRAMNVPROC			 	glIsProgramNV = NULL;
#endif // _WIN32

int CheckForNVVertexProgramSupport(void) {
	const char search[]="GL_NV_vertex_program";
	char string[10000];
	int pos=0;
	int maxpos=strlen(search)-1;
	strcpy(string,(const char *)glGetString(GL_EXTENSIONS));
	int len=strlen(string);	
	for (int i=0; i<len; i++) {
		if ((i==0) || ((i>1) && string[i-1]==' ')) {
			pos=0;									
			while (string[i]!='\n') {				
				if (string[i]==search[pos]) pos++;	
				if ((pos>maxpos) && string[i+1]==' ') {
					printf(search);
					printf(" supported.\n");
					return 1;
				}
				i++;
			}			
		}
	}	
	fprintf(stderr,search);
	fprintf(stderr," not supported.\n");
	return 0;	
}

int GL_NV_vertex_program_Init(void) {
	if (!CheckForNVVertexProgramSupport()) return 0;

#ifdef _WIN32
	glBindProgramNV = (PFNGLBINDPROGRAMNVPROC)	wglGetProcAddress("glBindProgramNV");
		if (glBindProgramNV==NULL) {fprintf(stderr,"glBindProgramNV not found.\n"); return 0; }
	glDeleteProgramsNV = (PFNGLDELETEPROGRAMSNVPROC) wglGetProcAddress("glDeleteProgramsNV");
		if (glDeleteProgramsNV==NULL) {fprintf(stderr,"glDeleteProgramsNV not found.\n"); return 0; }	
	glExecuteProgramNV = (PFNGLEXECUTEPROGRAMNVPROC) wglGetProcAddress("glExecuteProgramNV");
		if (glExecuteProgramNV==NULL) {fprintf(stderr,"glExecuteProgramNV not found.\n"); return 0; }
	glGenProgramsNV = (PFNGLGENPROGRAMSNVPROC) wglGetProcAddress("glGenProgramsNV");
		if (glGenProgramsNV==NULL) {fprintf(stderr,"glGenProgramsNV not found.\n"); return 0; }
	glRequestResidentProgramsNV = (PFNGLREQUESTRESIDENTPROGRAMSNVPROC) wglGetProcAddress("glRequestResidentProgramsNV");
		if (glRequestResidentProgramsNV==NULL) {fprintf(stderr,"glRequestResidentProgramsNV not found.\n"); return 0; }
	glGetProgramParameterfvNV = (PFNGLGETPROGRAMPARAMETERFVNVPROC) wglGetProcAddress("glGetProgramParameterfvNV");
		if (glGetProgramParameterfvNV==NULL) {fprintf(stderr,"glGetProgramParameterfvNV not found.\n"); return 0; }
	glGetProgramParameterdvNV = (PFNGLGETPROGRAMPARAMETERDVNVPROC) wglGetProcAddress("glGetProgramParameterdvNV");
		if (glGetProgramParameterdvNV==NULL) {fprintf(stderr,"glGetProgramParameterdvNV not found.\n"); return 0; }	
	glGetProgramivNV = (PFNGLGETPROGRAMIVNVPROC) wglGetProcAddress("glGetProgramivNV");
		if (glGetProgramivNV==NULL) {fprintf(stderr,"glGetProgramivNV not found.\n"); return 0; }	
	glGetProgramStringNV = (PFNGLGETPROGRAMSTRINGNVPROC) wglGetProcAddress("glGetProgramStringNV");
		if (glGetProgramStringNV==NULL) {fprintf(stderr,"glGetProgramStringNV not found.\n"); return 0; }	
	glGetTrackMatrixivNV = (PFNGLGETTRACKMATRIXIVNVPROC) wglGetProcAddress("glGetTrackMatrixivNV");
		if (glGetTrackMatrixivNV==NULL) {fprintf(stderr,"glGetTrackMatrixivNV not found.\n"); return 0; }	
	glGetVertexAttribdvNV = (PFNGLGETVERTEXATTRIBDVNVPROC) wglGetProcAddress("glGetVertexAttribdvNV");
		if (glGetVertexAttribdvNV==NULL) {fprintf(stderr,"glGetVertexAttribdvNV not found.\n"); return 0; }	
	glGetVertexAttribfvNV = (PFNGLGETVERTEXATTRIBFVNVPROC) wglGetProcAddress("glGetVertexAttribfvNV");
		if (glGetVertexAttribfvNV==NULL) {fprintf(stderr,"glGetVertexAttribfvNV not found.\n"); return 0; }	
	glGetVertexAttribivNV = (PFNGLGETVERTEXATTRIBIVNVPROC) wglGetProcAddress("glGetVertexAttribivNV");
		if (glGetVertexAttribivNV==NULL) {fprintf(stderr,"glGetVertexAttribivNV not found.\n"); return 0; }	
	glGetVertexAttribPointerNV = (PFNGLGETVERTEXATTRIBPOINTERNVPROC) wglGetProcAddress("glGetVertexAttribPointerNV");
		if (glGetVertexAttribPointerNV==NULL) {fprintf(stderr,"glGetVertexAttribPointerNV not found.\n"); return 0; }					 
	glLoadProgramNV = (PFNGLLOADPROGRAMNVPROC) wglGetProcAddress("glLoadProgramNV");
		if (glLoadProgramNV==NULL) {fprintf(stderr,"glLoadProgramNV not found.\n"); return 0; }			
	glProgramParameter4dNV = (PFNGLPROGRAMPARAMETER4DNVPROC) wglGetProcAddress("glProgramParameter4dNV");
		if (glProgramParameter4dNV==NULL) {fprintf(stderr,"glProgramParameter4dNV not found.\n"); return 0; }			
	glProgramParameter4fNV = (PFNGLPROGRAMPARAMETER4FNVPROC) wglGetProcAddress("glProgramParameter4fNV");
		if (glProgramParameter4fNV==NULL) {fprintf(stderr,"glProgramParameter4fNV not found.\n"); return 0; }			
	glProgramParameter4dvNV = (PFNGLPROGRAMPARAMETER4DVNVPROC) wglGetProcAddress("glProgramParameter4dvNV");
		if (glProgramParameter4dvNV==NULL) {fprintf(stderr,"glProgramParameter4dvNV not found.\n"); return 0; }			
	glProgramParameter4fvNV = (PFNGLPROGRAMPARAMETER4FVNVPROC) wglGetProcAddress("glProgramParameter4fvNV");
		if (glProgramParameter4fvNV==NULL) {fprintf(stderr,"glProgramParameter4fvNV not found.\n"); return 0; }			
	glProgramParameters4dvNV = (PFNGLPROGRAMPARAMETERS4DVNVPROC) wglGetProcAddress("glProgramParameters4dvNV");
		if (glProgramParameters4dvNV==NULL) {fprintf(stderr,"glProgramParameters4dvNV not found.\n"); return 0; }			
	glProgramParameters4fvNV = (PFNGLPROGRAMPARAMETERS4FVNVPROC) wglGetProcAddress("glProgramParameters4fvNV");
		if (glProgramParameters4fvNV==NULL) {fprintf(stderr,"glProgramParameters4fvNV not found.\n"); return 0; }			
	glTrackMatrixNV = (PFNGLTRACKMATRIXNVPROC) wglGetProcAddress("glTrackMatrixNV");
		 if (glTrackMatrixNV==NULL) {fprintf(stderr,"glTrackMatrixNV not found.\n"); return 0; }			
	glVertexAttribPointerNV = (PFNGLVERTEXATTRIBPOINTERNVPROC) wglGetProcAddress("glVertexAttribPointerNV");
		if (glVertexAttribPointerNV==NULL) {fprintf(stderr,"glVertexAttribPointerNV not found.\n"); return 0; }					 
	glVertexAttrib1sNV = (PFNGLVERTEXATTRIB1SNVPROC) wglGetProcAddress("glVertexAttrib1sNV");
		if (glVertexAttrib1sNV==NULL) {fprintf(stderr,"glVertexAttrib1sNV not found.\n"); return 0; }					 
	glVertexAttrib1fNV = (PFNGLVERTEXATTRIB1FNVPROC) wglGetProcAddress("glVertexAttrib1fNV");
		if (glVertexAttrib1fNV==NULL) {fprintf(stderr,"glVertexAttrib1fNV not found.\n"); return 0; }					 
	glVertexAttrib1dNV = (PFNGLVERTEXATTRIB1DNVPROC) wglGetProcAddress("glVertexAttrib1dNV");
		if (glVertexAttrib1dNV==NULL) {fprintf(stderr,"glVertexAttrib1dNV not found.\n"); return 0; }					 
	glVertexAttrib2sNV = (PFNGLVERTEXATTRIB2SNVPROC) wglGetProcAddress("glVertexAttrib2sNV");
		if (glVertexAttrib2sNV==NULL) {fprintf(stderr,"glVertexAttrib2sNV not found.\n"); return 0; }					 
	glVertexAttrib2fNV = (PFNGLVERTEXATTRIB2FNVPROC) wglGetProcAddress("glVertexAttrib2fNV");
		if (glVertexAttrib2fNV==NULL) {fprintf(stderr,"glVertexAttrib2fNV not found.\n"); return 0; }					 
	glVertexAttrib2dNV = (PFNGLVERTEXATTRIB2DNVPROC) wglGetProcAddress("glVertexAttrib2dNV");
		if (glVertexAttrib2dNV==NULL) {fprintf(stderr,"glVertexAttrib2dNV not found.\n"); return 0; }					 
	glVertexAttrib3sNV = (PFNGLVERTEXATTRIB3SNVPROC) wglGetProcAddress("glVertexAttrib3sNV");
		if (glVertexAttrib3sNV==NULL) {fprintf(stderr,"glVertexAttrib3sNV not found.\n"); return 0; }					 
	glVertexAttrib3fNV = (PFNGLVERTEXATTRIB3FNVPROC) wglGetProcAddress("glVertexAttrib3fNV");
		if (glVertexAttrib3fNV==NULL) {fprintf(stderr,"glVertexAttrib3fNV not found.\n"); return 0; }					 
	glVertexAttrib3dNV = (PFNGLVERTEXATTRIB3DNVPROC) wglGetProcAddress("glVertexAttrib3dNV");
		if (glVertexAttrib3dNV==NULL) {fprintf(stderr,"glVertexAttrib3dNV not found.\n"); return 0; }					 
	glVertexAttrib4sNV = (PFNGLVERTEXATTRIB4SNVPROC) wglGetProcAddress("glVertexAttrib4sNV");
		if (glVertexAttrib4sNV==NULL) {fprintf(stderr,"glVertexAttrib4sNV not found.\n"); return 0; }					 
	glVertexAttrib4fNV = (PFNGLVERTEXATTRIB4FNVPROC) wglGetProcAddress("glVertexAttrib4fNV");
		if (glVertexAttrib4fNV==NULL) {fprintf(stderr,"glVertexAttrib4fNV not found.\n"); return 0; }					 
	glVertexAttrib4dNV = (PFNGLVERTEXATTRIB4DNVPROC) wglGetProcAddress("glVertexAttrib4dNV");
		if (glVertexAttrib4dNV==NULL) {fprintf(stderr,"glVertexAttrib4dNV not found.\n"); return 0; }					 
	glVertexAttrib4ubNV = (PFNGLVERTEXATTRIB4UBNVPROC) wglGetProcAddress("glVertexAttrib4ubNV");
		if (glVertexAttrib4ubNV==NULL) {fprintf(stderr,"glVertexAttrib4ubNV not found.\n"); return 0; }					 
	glVertexAttrib1svNV = (PFNGLVERTEXATTRIB1SVNVPROC) wglGetProcAddress("glVertexAttrib1svNV");
		if (glVertexAttrib1svNV==NULL) {fprintf(stderr,"glVertexAttrib1svNV not found.\n"); return 0; }					 
	glVertexAttrib1fvNV = (PFNGLVERTEXATTRIB1FVNVPROC) wglGetProcAddress("glVertexAttrib1fvNV");
		if (glVertexAttrib1fvNV==NULL) {fprintf(stderr,"glVertexAttrib1fvNV not found.\n"); return 0; }					 
	glVertexAttrib1dvNV = (PFNGLVERTEXATTRIB1DVNVPROC) wglGetProcAddress("glVertexAttrib1dvNV");
		if (glVertexAttrib1dvNV==NULL) {fprintf(stderr,"glVertexAttrib1dvNV not found.\n"); return 0; }					 
	glVertexAttrib2svNV = (PFNGLVERTEXATTRIB2SVNVPROC) wglGetProcAddress("glVertexAttrib2svNV");
		if (glVertexAttrib2svNV==NULL) {fprintf(stderr,"glVertexAttrib2svNV not found.\n"); return 0; }					 
	glVertexAttrib2fvNV = (PFNGLVERTEXATTRIB2FVNVPROC) wglGetProcAddress("glVertexAttrib2fvNV");
		if (glVertexAttrib2fvNV==NULL) {fprintf(stderr,"glVertexAttrib2fvNV not found.\n"); return 0; }					 
	glVertexAttrib2dvNV = (PFNGLVERTEXATTRIB2DVNVPROC) wglGetProcAddress("glVertexAttrib2dvNV");
		if (glVertexAttrib2dvNV==NULL) {fprintf(stderr,"glVertexAttrib2dvNV not found.\n"); return 0; }					 
	glVertexAttrib3svNV = (PFNGLVERTEXATTRIB3SVNVPROC) wglGetProcAddress("glVertexAttrib3svNV");
		if (glVertexAttrib3svNV==NULL) {fprintf(stderr,"glVertexAttrib3svNV not found.\n"); return 0; }					 
	glVertexAttrib3fvNV = (PFNGLVERTEXATTRIB3FVNVPROC) wglGetProcAddress("glVertexAttrib3fvNV");
		if (glVertexAttrib3fvNV==NULL) {fprintf(stderr,"glVertexAttrib3fvNV not found.\n"); return 0; }					 
	glVertexAttrib3dvNV = (PFNGLVERTEXATTRIB3DVNVPROC) wglGetProcAddress("glVertexAttrib3dvNV");
		if (glVertexAttrib3dvNV==NULL) {fprintf(stderr,"glVertexAttrib3dvNV not found.\n"); return 0; }					 
	glVertexAttrib4svNV = (PFNGLVERTEXATTRIB4SVNVPROC) wglGetProcAddress("glVertexAttrib4svNV");
		if (glVertexAttrib4svNV==NULL) {fprintf(stderr,"glVertexAttrib4svNV not found.\n"); return 0; }					 
	glVertexAttrib4fvNV = (PFNGLVERTEXATTRIB4FVNVPROC) wglGetProcAddress("glVertexAttrib4fvNV");
		if (glVertexAttrib4fvNV==NULL) {fprintf(stderr,"glVertexAttrib4fvNV not found.\n"); return 0; }					 
	glVertexAttrib4dvNV = (PFNGLVERTEXATTRIB4DVNVPROC) wglGetProcAddress("glVertexAttrib4dvNV");
		if (glVertexAttrib4dvNV==NULL) {fprintf(stderr,"glVertexAttrib4dvNV not found.\n"); return 0; }					 
	glVertexAttrib4ubvNV = (PFNGLVERTEXATTRIB4UBVNVPROC) wglGetProcAddress("glVertexAttrib4ubvNV");
		if (glVertexAttrib4ubvNV==NULL) {fprintf(stderr,"glVertexAttrib4ubvNV not found.\n"); return 0; }				
	glAreProgramsResidentNV = (PFNGLAREPROGRAMSRESIDENTNVPROC) wglGetProcAddress("glAreProgramsResidentNV");
	 	 if (glAreProgramsResidentNV==NULL) {fprintf(stderr,"glAreProgramsResidentNV not found.\n"); return 0; }				
	glIsProgramNV = (PFNGLISPROGRAMNVPROC) wglGetProcAddress("glIsProgramNV");
		if (glIsProgramNV==NULL) {fprintf(stderr,"glIsProgramNV not found.\n"); return 0; }		
#endif // _WIN32
	return 1;
}
	
#endif // NV_VERTEX_PROGRAM_INITIALIZE

#ifdef __cplusplus
}

#endif

#endif // not __NV_VERTEX_PROGRAM_H_
