#ifndef __MODELLS_H__
#define __MODELLS_H__

// FRAME OF THE POOL IN T3F-N3F-V3F QUADS-FORMAT
#define frame_entries 36

static GLfloat frame[]={ 
        /* 
         *  TOP LEFT
         *
         */ 
         -1, 0.00,-1,  0, 1, 0,    -2.4,0,-2,  
         -1,-0.25,-1,  0, 1, 0,    -2.0,0,-2,
         -1,-0.25, 1,  0, 1, 0,    -2.0,0,+2,
         -1, 0.00, 1,  0, 1, 0,    -2.4,0,+2,  
        /* 
         *  TOP RIGHT
         *
         */ 
         +1, 0.00,-1,  0, 1, 0,    +2.4,0,-2,  
         +1,-0.25,-1,  0, 1, 0,    +2.0,0,-2,
         +1,-0.25, 1,  0, 1, 0,    +2.0,0,+2,
         +1, 0.00, 1,  0, 1, 0,    +2.4,0,+2,  
        /* 
         *  TOP FRONT
         *
         */ 
         -1, 0.00,+1,  0, 1, 0,    -2.0,0,+2.4,  
         -1,-0.25,+1,  0, 1, 0,    -2.0,0,+2.0,
          1,-0.25,+1,  0, 1, 0,    +2.0,0,+2.0,
          1, 0.00,+1,  0, 1, 0,    +2.0,0,+2.4,  
        /* 
         *  TOP BACK
         *
         */ 
         -1, 0.00,-1,  0, 1, 0,    -2.0,0,-2.4,  
         -1,-0.25,-1,  0, 1, 0,    -2.0,0,-2.0,
          1,-0.25,-1,  0, 1, 0,    +2.0,0,-2.0,
          1, 0.00,-1,  0, 1, 0,    +2.0,0,-2.4,  
	 
	/*
	 *  RIGHT
	 *
	 */
	 -1,-0,-1,    -0.8, 0.6, 0,    -2, 0,-2,
	 -1,-1,-1,    -0.8, 0.6, 0,    -2,-2,-2,
	 -1,-1, 1,    -0.8, 0.6, 0,    -2,-2,+2,
	 -1,-0, 1,    -0.8, 0.6, 0,    -2, 0,+2,
	/*
	 *  LEFT
	 *
	 */
	  1, 0, 1,     0.8, 0.6, 0,    +2, 0,+2,
	  1,-1, 1,     0.8, 0.6, 0,    +2,-2,+2,
	  1,-1,-1,     0.8, 0.6, 0,    +2,-2,-2,		 
	  1, 0,-1,     0.8, 0.6, 0,    +2, 0,-2,
	/*
	 *  FRONT
	 *
	 */
	  1, 0,-1,     0, 0.6,-0.8,    +2, 0,-2,
	  1,-1,-1,     0, 0.6,-0.8,    +2,-2,-2,
	 -1,-1,-1,     0, 0.6,-0.8,    -2,-2,-2,		 
	 -1, 0,-1,     0, 0.6,-0.8,    -2, 0,-2,
	/*
	 *  BACK
	 *
	 */
         -1, 0, 1,     0, 0.6,+0.8,    -2, 0,+2,
	 -1,-1, 1,     0, 0.6,+0.8,    -2,-2,+2,
	  1,-1, 1,     0, 0.6,+0.8,    +2,-2,+2,
	  1, 0, 1,     0, 0.6,+0.8,    +2, 0,+2,
	/*
	 *  BOTTOM
	 *
	 */
	  1,-1,-1,     0,-1, 0,        +2,-2,-2,
	  1,-1,+1,     0,-1, 0,	       +2,-2,+2,
	 -1,-1,+1,     0,-1, 0,	       -2,-2,+2,		 
	 -1,-1,-1,     0,-1, 0,	       -2,-2,-2
};

#ifndef M_PI
#define M_PI 3.141592654f
#endif

void drawArrow(void) {
  float di=2*M_PI/10.0f;
  float i;
  glBegin(GL_QUADS);
    for (i=0; i<2*M_PI; i+=di) {
      glNormal3f(0,cos(i),sin(i));
      glVertex3f(-0.5,0.05*cos(i),0.05*sin(i));
      glNormal3f(0,cos(i+di),sin(i+di));
      glVertex3f(-0.5,0.05*cos(i+di),0.05*sin(i+di));
      glNormal3f(0,cos(i+di),sin(i+di));
      glVertex3f(+0.3,0.05*cos(i+di),0.05*sin(i+di));
      glNormal3f(0,cos(i),sin(i));
      glVertex3f(+0.3,0.05*cos(i),0.05*sin(i));
    }
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
  glNormal3f(-1,0,0);
  glVertex3f(-0.5,0.0f,0.0f);
    for (i=0; i<2*M_PI; i+=di) {
      glVertex3f(-0.5,0.05*cos(i),0.05*sin(i));
    }
    glVertex3f(-0.5,0.05,0);
  glEnd();
  glBegin(GL_TRIANGLE_FAN);
    glNormal3f(1,0,0);
    glVertex3f(+0.5,0.0f,0.0f);
    for (i=0; i<2*M_PI; i+=di) {
      glNormal3f(0.33f,0.94f*cos(i),0.94f*sin(i));
      glVertex3f(+0.3,0.1*cos(i),0.1*sin(i));
    }
    glNormal3f(0.33f,0.94f,0);
    glVertex3f(+0.3,0.1,0);
  glEnd();
}
    
#endif